!- TRIANGULAR μOS 1.33 for Commodore 128
!- UOS


!- Set BASIC variables & launch hardware tests & set memory variables :: set poke808 to 110/105 for enable/disable Run/Stop key
0graphic0,1:clr:slow:print"{ct h}{cyan}{142}{27}l":poke808,105:poke53269,.:color4,1:color0,1:q$=chr$(34):vr=1.33:pa=65532:gosub92:gosub8:iffre(x)<53200thenn$="not enough ram!":goto22
1gosub20:fm=128:gosub8:gosub9:dd=1:poke3069,fm:poke3060,dd:poke3061,.:poke3066,158:poke3065,31:poke3067,.:poke3068,230:poke3062,1:poke3063,130:poke3064,184:vt=vr*100:poke3050,vt:bs=peek(3000):ifbs<8andbs>11thenbs=8

!- Launch screen
2bi=.:print"{clear}";:gosub8:print"{down*2}{purple}{cm @*40}";:gosub54:printtab(13)"{cm asterisk}{reverse on}            {reverse off}{sh pound}":gosub55:printtab(15)"{cm asterisk}{reverse on}        {reverse off}{sh pound}":gosub55:printtab(17)"{cm asterisk}{reverse on}    {reverse off}{sh pound}":gosub55:printtab(19)"{cm asterisk}{sh pound}":gosub55
3print"{down}{blue}{space*2}{cm c}{reverse on}{cm d}{cm k}{reverse off}{cm b}{reverse on}{cm k}{reverse off}{cm d}{cm b}{reverse on}{cm k}{reverse off}{cm f}{cm k}{reverse on}{cm b}{reverse off}{cm v}{cm k*3} {reverse on}{cm b}{reverse off}{cm f}{reverse on}{cm d}{reverse off}{cm f}{space*3}{light green}{reverse on}{cm d}{reverse off}{cm k}{reverse on}{cm d}{reverse off}{cm v}{cyan}"vr"{return}{blue}{space*3}{cm k}{reverse on}{cm k}{reverse off}{cm b}{reverse on}{cm k*2}{cm f}{cm k}{reverse off}{cm c}{cm k*6} {reverse on}{cm d}{reverse off}{cm k}{reverse on}{cm d}{reverse off}{cm f} {orange}{cm k*2}{light green}{cm k*2}{reverse on}{cm i}{reverse off}{cm k}{return}{blue}{space*3}{cm v}{cm c*6} {cm v}{cm c}{cm v}{reverse on}{cm i}{reverse off}{cm v}{reverse on}{cm i}{reverse off}{cm v*5} {reverse on}{orange}{cm i}{reverse off}{cm k}{reverse on}{light green}{cm i}{reverse off}{cm v}{reverse on}{cm i}{reverse off}{cm v} {light gray}(c) 2023"
4gosub8:ifrn=.then72
5printtab(26)"{down*4}{reverse on}{yellow}f1{reverse off} {green}bios setup";:poke208,.:gosub11
6getk$:ifk$="{f1}"then25

!- Load GUI
7n$="gui":l$=" loading...":print"{purple}";:gosub88:goto89

!- Delay 0.6s
8sleep0.6:return

!- Beep sound
9vol15:sound1,9472,10,0,0,0,0,0:forj=.to150:nextj:return

!- Beep sound x3
10gosub9:gosub9:gosub9:return

!- Delay 2s
11sleep2:return

!- Disk dirve tests (drive # evaluatian: 8+di)
12open1,8+di,2:close1:ifst<>.then16
13gosub19:ifer$=""then16
14open1,8+di,15:print#1,"m-r";chr$(51);chr$(255):get#1,d$:t1=asc(d$+chr$(.)):close1:vt=0:open5,8+di,5,"uos.cfg,s,r":input#5,vt:close5:gosub19:poke3011+di,1:poke3015+di,t1:bi=1:ifvr=vtthengoto17
15return
16poke3011+di,.:poke3015+di,.:return
17bd=8+di:ifbs=bdthent=1
18return

!- Read disk error channel
19open1,8+di,15:input#1,en$,er$,tr$,sc$:close1:return

!- Commodore 128 type confirmation
20poke208,.:poke842,167:poke843,189:poke208,2:getk$:geta$:k$=k$+a$:ifk$="{cm m}{cm x}"andpeek(pa)=61andpeek(pa+1)=255then23
21n$="can't run this{cm m}{cm x}os version!"

!- Shut down with error message
22l$="shut down...":print"{red}";:gosub88:print"{home}{red}"n$:gosub8:gosub10:goto94

!- Set up initial memory variables & cursor test & screen mode detection
23poke3071,6:restore23:fori=.to5:readj:poke3051+i,j:nexti:print"{clear}{down}{cm p}";:gosub8:ifpeek(((peek(2619))*256)+40)=111thenpoke3070,40:fori=1to8:keyi,chr$(i+132):nexti:return:data19,13,82,85,78,13
24print"{clear}":gosub8:n$="this graphic mode is not supported!":goto22

!- BIOS Setup menu
25print"{clear}{down}{purple} {cm asterisk}{reverse on}{space*2}{reverse off}{sh pound}{cyan} triangular bios"vr"{return}{space*2}{purple}{cm asterisk}{sh pound}{cyan}{space*2}(c) 2023{down*2}{return}{space*2}{light green}commodore {orange}128{cyan}{space*2}ram:"fm"{left}kb{down}{return}{space*3}#: device:{space*9}boot/work":cs$="none":ifcs=1thencs$="cbm datasette":
26db=dd:wb=wd:bb=bd:print"   {reverse on}{red}1{cyan}{reverse off}: ":gosub80:fori=.to3
27gosub60:print"  "8+i;"{left}:",:ifdi(i)=.thenprint"{left*7}none"
28ifdi(i)=1thenprint"{left*4}cbm "dt$(i)"{return}","{up}{right*13}{reverse on}{yellow}"(i*2)+1"{left*3}f{right*3}{green}"(i*2)+2"{left*3}f{reverse off}{cyan}"
29nexti:print"{down}   boot:     work:{return}{down*2}  {reverse on}{red}t{cyan}{reverse off}ime:{return}{down}  {reverse on}{red}r{cyan}{reverse off}eset clock{return}{down*2}  {reverse on}{red}e{cyan}{reverse off}xit {reverse on}{red}s{cyan}{reverse off}ave {reverse on}{red}b{cyan}{reverse off}asic":poke208,.
30gosub56:gosub59:getk$:ifk$=""then30
31ifk$="e"thenprint"{clear}":dd=db:wd=wb:bd=bb:goto2
32ifk$="r"thenti$="000000"
33ifk$="1"thengosub82:gosub80
34ifk$="{f1}"theni=.:gosub57
35ifk$="{f2}"theni=.:gosub58
36ifk$="{f3}"theni=1:gosub57
37ifk$="{f4}"theni=1:gosub58
38ifk$="{f5}"theni=2:gosub57
39ifk$="{f6}"theni=2:gosub58
40ifk$="{f7}"theni=3:gosub57
41ifk$="{f8}"theni=3:gosub58
42ifk$="t"thengosub48
43ifk$="s"then46
44ifk$="b"then91
45goto30

46open1,bd,15,"r0:uos=uos":close1:gosub79:ifer$="ok"thengosub9:gosub9:goto30
47gosub78:goto90

!- Time change
48gosub93:print"{white} {arrow left} {cyan}type new time":ks$="":kv$="":poke208,.:fori=.to5
49gosub56:gosub59:print"{down}{right*8}{light green}"kv$"{cyan}":getk$:ifk$=""then49
50as=asc(k$):ifas>47andas<58thenks$=ks$+k$:goto52
51goto49

!- Time change display
52kv$=kv$+k$:ifi=1ori=3thenkv$=kv$+":"
53nexti:gosub93::print"                 ":ti$=ks$:poke208,.:return

!- Draw horizontal line 1
54print"{sh asterisk*40}":return

!- Draw horizontal line 2
55print"{cm t*40}":return

!- Time update > setup
56t$=ti$:t1$=left$(t$,2):t2$=mid$(t$,3,2):t3$=right$(t$,2):print"{home}{down*17}{right*8}"t1$":"t2$":"t3$:return

!- Set Boot drive
57ifpeek(3011+i)=1thenbd=8+i:return:elsereturn

!- Set Work drive
58ifpeek(3011+i)=1thenwd=8+i:return:elsereturn

!- Boot & Work disk drive update > setup
59print"{home}{down*14}{right*8}{yellow}"bd"{left} ","{left*2}{green}"wd"{left} {cyan}":return

!- Disk drive database
60di(i)=peek(3011+i):dn(i)=peek(3015+i):dt$(i)="{left*4}unknown":ifdi(i)=.thenreturn
61ifdn(i)=16thendt$(i)="2040"
62ifdn(i)=76thendt$(i)="1541-ii"
63ifdn(i)=170thendt$(i)="1541"
64ifdn(i)=173thendt$(i)="1571"
65ifdn(i)=108thendt$(i)="1581"
66ifdn(i)=7thendt$(i)="2031"
67ifdn(i)=32thendt$(i)="3040"
68ifdn(i)=169thendt$(i)="4040"
69ifdn(i)=255thendt$(i)="1551"
70ifdn(i)=48thendt$(i)="{left*4}sd2iec"
71return

!- Check disk drives
72t=.:fordi=3to.step-1:gosub12:nextdi:ift=1thenbd=bs
73wd=bd:poke3000,bd:poke3001,wd:ifbi=.thenee$="   {reverse on}no disk drive!{reverse off}":goto84
74ifbd=.thenee$="   {reverse on}no system disk!{reverse off}":goto84

!- Load uos.cfg
75rn=1:open8,bd,8,"uos.cfg,s,r":close8:gosub79:poke3062,1:ifer$<>"ok"then84
76open8,bd,8,"uos.cfg,s,r":input#8,v1$,wd$,dd$,gc$,gr$,cg$,tc$,pp$:close8:gosub79:poke3068,val(gr$):poke3067,val(gc$):poke3065,val(cg$):wd=val(wd$):dd=val(dd$):poke3060,dd:ifpeek(963+wd)=.thenwd=bd
77poke3001,wd:poke3066,val(tc$):poke3061,val(pp$):goto5

!- Save uos.cfg
78open1,bd,15,"s0:uos.cfg":close1:open8,bd,8,"uos.cfg,w,s":print#8,vr:print#8,wd:print#8,dd:print#8,peek(3067):print#8,peek(3068):print#8,peek(3065)::print#8,peek(3066):print#8,peek(3061):close8:poke3060,dd:poke3000,bd:poke3001,wd:gosub79:return

!- Read disk error chanell
79open1,bd,15:input#1,en$,er$,tr$,sc$:close1:return

!- Update Datasette status graphic > setup
80ifdd=.thenprint"{home}{down*8}{right*6}none         ":return
81ifdd=1thenprint"{home}{down*8}{right*6}cbm datasette":return:elsereturn

!- Datasette enable On/Off
82ifdd=.thendd=1:return
83ifdd=1thendd=.:return:elsereturn


!- Disk drive error
84printtab(9)"{down*2}{red}"ee$"{return}{down}{yellow} {reverse on}f1{green}{reverse off} retry"tab(31)"{red}{reverse on}f8{green}{reverse off} basic";:poke208,.:gosub10
85getk$:ifk$="{f1}"thenrn=.:print"{up*3}{black}":fori=.to2:print"{space*38}":nexti:print"{delete*2}{up*5}":goto4
86ifk$="{f8}"then91
87goto85

!- Draw load
88print"{clear}{down*15}"tab(17)"{cm asterisk}{reverse on}    {reverse off}{sh pound}{return}"tab(18)"{cm asterisk}{reverse on}  {reverse off}{sh pound}{return}"tab(19)"{cm asterisk}{sh pound}{return}{down}{white}"tab(12)"{cm @*16}{return}{white}"tab(11)"{cm m}{reverse on}{blue}{cm m*9}{reverse off}       {white}{cm g}{return}{white}"tab(12)"{cm t*16}{return}{white}{down}"tab(9)"     "l$:return

!- Load sequence
89print"{home}{black}load "q$n$q$","bd:poke208,.:fori=.to5:g=peek(3051+i):poke842+i,g:nexti:poke208,6:new

!- Restaring
90l$="restarting...":print"{yellow}";:gosub88:n$="uos":goto89

!- Shut down
91l$="shut down...":print"{red}";:gosub88:goto94

!- Clear SID
92vol0:fori=1to3:soundi,0,0,0,0,0,0,0:nexti:return

!- Clear Time changer
93gosub59:print"{down}{right*8}       ";:return

!- Shut down perform reset
94gosub11:print"{clear}":sys57344
